import dbus


def isMountedUsbVolume(bus, dev_int):
    try:
        if isUsbVolume(bus, dev_int): 
            return dev_int.GetProperty("volume.is_mounted")

        return False

    except dbus.DBusException, e:
        pass
# only works for newer dbus
#        if not e.get_dbus_name() in ["org.freedesktop.Hal.NoSuchProperty"]:
#            raise

def isUsbVolume(bus, dev_int):
    try:
        parent_udi = dev_int.GetProperty("info.parent")
        parent_obj = bus.get_object ('org.freedesktop.Hal', parent_udi)
        parent_int =  dbus.Interface (parent_obj, 'org.freedesktop.Hal.Device')

        if parent_int.GetProperty("storage.bus") != "usb":
            return

        if parent_int.GetProperty("storage.drive_type") != "disk":
            return

        return dev_int.GetProperty("block.is_volume")

    except dbus.DBusException, e:
        pass
# only works for newer dbus
#        if not e.get_dbus_name() in ["org.freedesktop.Hal.NoSuchProperty"]:
#            raise

