import os
import sys
import ConfigParser
import fcntl

def initDefaultConfig():
    # set config defaults (overridden by bios_autoupdate.ini)
    cfg = ConfigParser.ConfigParser()
    cfg.add_section("usb_auto_update")
    # "update-auto", "update-ask", "update-disable"
    cfg.set("usb_auto_update", "update_type", "update-auto")
    cfg.set("usb_auto_update", "reboot_after_update", "0")
    return cfg

def lockSession(filename):
    lockFh = file(filename, "w")
    try:
        fcntl.flock( lockFh.fileno(), fcntl.LOCK_EX | fcntl.LOCK_NB )
        return lockFh
    except IOError:
        return None

def daemonize(stdout="/dev/null", stderr="/dev/null", stdin="/dev/null"):
    try: 
        pid = os.fork() 
        if pid: sys.exit(0) # parent
    except OSError, e: 
        sys.stderr.write("fork #1 failed: (%d) %s\n" % (e.errno, e.strerror))
        sys.exit(1)
        
    # child
    os.chdir("/") 
    os.umask(0) 
    os.setsid() 
    
    # fork again
    try: 
        pid = os.fork() 
        if pid: sys.exit(0) # parent #2
    except OSError, e: 
        sys.stderr.write("fork #2 failed: (%d) %s\n" % (e.errno, e.strerror))
        sys.exit(1)
    
    si = file(stdin, 'r') 
    so = file(stdout, 'a+')
    se = file(stderr, 'a+', 0)
    os.dup2(si.fileno(), sys.stdin.fileno())
    os.dup2(so.fileno(), sys.stdout.fileno())
    os.dup2(se.fileno(), sys.stderr.fileno()) 
    si.close()
    so.close()
    se.close()

    return pid
 
